﻿// Описание интерфейсов работы с окнами
:tdef HWND uint32
:tdef HDC uint32
:tdef COLORREF uint32
:tdef HICON uint32
:tdef HMENU uint32

:iface IView {B105A780-F121-11d3-93F7-008048DA11F9}
:virt
    void drawView(HDC dc, const Rect& rect, const Rect& updateRect)
    bool setViewEnable(bool enable)
    bool isViewEnable()
    Size getViewExtent()
	+1	//void setViewRects(const Rect& rect, HDWP* pDWP = 0)
    void getMinMaxExtent(Size& minExtent, Size& maxExtent)

:iface IWindowView {E3F69D70-0188-11d4-9400-008048DA11F9}
:base IView
:virt
	+1
    save bool createWindow(HWND parentWindow)
    void destroyWindow()
    bool showWindow(bool show)
    bool isWindowVisible()
    void moveAfter(HWND wnd)
    void invalidateRect(const Rect& rect, bool eraseBkgnd = true)
    HWND hwnd()
    void windowRect(Rect& rect)
    COLORREF getWindowBackgroundColor()

:enum CloseAction
	DelOnClose
	HideOnClose
	NoClose

:enum ActivateType
	atActivate
	atDeactivate
	atKillFocus
	atSetFocus

:iface IFramedView {7C27C850-A0F4-11d4-84AF-008048DA06DF}
:virt
	void setID(const Guid&in id)
	uint getID(Guid&out)
	CloseAction closeAction()
	+1
	// Заголовок
	v8string title()
	// Иконка
	uint icon(IUnknown@&out)
	// извещение об активизации
	void onActivate(ActivateType action, IFramedView@ otherView)
	// установка фокуса
	void setViewFocus()
	// окончание создания
	save bool onInitialUpdate()
	// окончание создания и показ окна
	save void onFinalOpen()
	void onFinalClose()
	void onCancelClose()
	bool canCloseView()
	void onShow(bool show)

:enum TopLevelFrameType
	eTLFT_Unknown
	eTLFT_Main
	eTLFT_Hidden

:enum ViewState
	1 vsDock
	2 fsFloat
	4 vsMDI
	8 vsHardDock
	16 vsAutoHide

:iface ITopLevelFrame {DE300901-A120-11d4-9429-008048DA11F9}
:virt
    void init(const v8string&in title, HICON icon, HWND parent, const Rect&in rect, int nCmdShow)
    bool close(bool testAbility = false)
    bool canClose()
    void cancelClose()
    int frameType()
